<template>
  <md-app>
    <md-app-drawer class="md-scrollbar sorts-and-filters-drawer" md-permanent="full">
      <md-toolbar class="md-transparent" md-elevation="0">
        <md-autocomplete v-model="search" :md-options="collections" :md-dense="true" v-on:md-selected="select($event)" md-layout="box">
          <label>Search a collection</label>
          <template slot="md-autocomplete-item" slot-scope="{item}">{{item.title}}</template>
          <template slot="md-autocomplete-empty">No collection found</template>
        </md-autocomplete>
      </md-toolbar>
      <md-list>
        <md-subheader>Sort by</md-subheader>
        <md-list-item v-for="sort in sorts" :key="sort.value">
          <md-radio v-model="selectedSort" :value="sort.value"/>
          <span class="md-list-item-text">{{sort.title}}</span>
        </md-list-item>
      </md-list>
      <md-list>
        <md-subheader>Collection type</md-subheader>
        <md-list-item v-for="type in collectionTypesMap" :key="type.value">
          <md-checkbox v-model="selectedCollectionTypes" :value="type.value"/>
          <span class="md-list-item-text">{{type.title}}</span>
        </md-list-item>
      </md-list>
    </md-app-drawer>
    <md-app-content>
      <md-dialog
        :md-close-on-esc="false"
        :md-click-outside-to-close="false"
        :md-active.sync="showNewCollectionDialog"
        v-on:md-opened="initNewCollection"
        v-on:md-closed="resetNewCollection">
        <md-dialog-title>Start your new collection</md-dialog-title>
        <md-dialog-content v-if="newCollection">
          <md-field>
            <label>Title</label>
            <md-input v-model="newCollection.title" required></md-input>
          </md-field>
          <md-field>
            <label>Collection type</label>
            <md-select v-model="newCollection.type" required>
              <md-option v-for="key in collectionTypes" :key="key" :value="key">
                {{collectionTypesMap[key].title}}
              </md-option>
            </md-select>
          </md-field>
        </md-dialog-content>
        <md-dialog-actions>
          <md-button @click="showNewCollectionDialog = false">Cancel</md-button>
          <md-button class="md-primary" @click="addCollection" :disabled="!isNewCollectionFormValid">Let's go !</md-button>
        </md-dialog-actions>
      </md-dialog>
      <div class="md-layout collections-grid">
        <div
          class="md-layout-item md-size-33 md-medium-size-50 md-small-size-100 md-xsmall-size-100"
          v-for="collection in filteredCollections"
          :key="collection.id">
          <md-card class="md-primary" md-theme="black-card">
            <md-card-header>
              <md-avatar>
                <md-icon aria-hidden="true">{{collectionTypesMap[collection.type].icon}}</md-icon>
              </md-avatar>
              <md-card-header-text>
                <div class="md-title">{{collection.title}}</div>
                <div class="md-subhead">{{collection.items.length}} items</div>
              </md-card-header-text>
            </md-card-header>
            <md-card-actions>
              <md-button :to="{ name: 'collection', params: { id: collection.id } }">Open collection</md-button>
            </md-card-actions>
          </md-card>
        </div>
      </div>
      <div class="fab-container">
        <md-button class="md-fab" aria-label="Start collection" @click="showNewCollectionDialog = true">
          <md-icon>add</md-icon>
          <md-tooltip md-direction="left">Start a new collection</md-tooltip>
        </md-button>
      </div>
    </md-app-content>
  </md-app>
</template>

<script>
import store from '@/store';
import { Collection } from '@/models/collection';
import { collectionTypes, collectionTypesMap } from '@/models/collection-type';

export default {
  data() {
    return {
      search: null,
      sorts: [
        { title: 'Name', value: 'title', sort: (a, b) => a.title.localeCompare(b.title) },
        { title: 'Last updated', value: '-updated', sort: (a, b) => b.updated.valueOf() - a.updated.valueOf() },
        { title: 'Last created', value: '-created', sort: (a, b) => b.created.valueOf() - a.created.valueOf() },
      ],
      selectedSort: '-updated',
      collectionTypes,
      collectionTypesMap,
      selectedCollectionTypes: collectionTypes,
      newCollection: null,
      showNewCollectionDialog: false,
    };
  },
  computed: {
    collections() {
      return this.$store.state.firebase.collections;
    },
    filteredCollections() {
      return this.$store.state.firebase.collections
        .filter((collection) => this.selectedCollectionTypes.indexOf(collection.type) !== -1)
        .sort(this.sorts.find((sort) => sort.value === this.selectedSort).sort);
    },
    isNewCollectionFormValid() {
      if (!this.newCollection) {
        return false;
      }
      return this.newCollection.title.trim().length > 0 && this.newCollection.type;
    },
  },
  methods: {
    select(collection) {
      this.$router.push({ name: 'collection', params: { id: collection.id } });
    },
    initNewCollection() {
      this.newCollection = new Collection();
    },
    resetNewCollection() {
      this.newCollection = null;
    },
    addCollection() {
      this.$store.commit('firebase/addCollection', this.newCollection);
      this.showNewCollectionDialog = false;
    },
  },
};
</script>

<style lang="scss">
.sorts-and-filters-drawer {
  width: 256px;
  border-right: 1px solid rgba(#fff, .12);
}

.collections-grid {
  padding: 16px 16px 84px;

  .md-layout-item {
    padding: 16px;

    .md-card {
      margin: 0 !important;
    }
  }
}
</style>
